/* Fold program 
 * Called from command line with:
 * Fold a1 ... an op b
 * where: a1 ... an and b are integers and op in {+,-}
 * E.g. : Fold 1 -2 3 - 4
*/

class Fold{

    /* prints description of the program and how to call it
     */
    private static void printDescription(){
	System.out.println("Syntax: Fold a1 ... an op b");
	System.out.println("With : a1 ... an and b are integers and op in {+,-}");
	System.out.println("E.g. : Fold 1 -2 3 - 4");
    }
    
    /* Program takes its arguments via command line
     * This method goes through them and prints the 
     * result of Fold
     */
    public static void main(String[] args)
    {
	if(args.length < 2){
	    printDescription();
	    return;
	}
	try{
	    int result = Integer.parseInt(args[args.length-1]);
	    if(args[args.length - 2].equals("+")){
		for(int i=0; i < args.length - 2; i++){
		    int value = Integer.parseInt(args[i]);
		    result = result + value;
		}
		System.out.println(result);
	    }else if(args[args.length - 2].equals("-")){
		for(int i=0; i < args.length - 2; i++){
		    int value = Integer.parseInt(args[i]);
		    result = result - value;
		}
		System.out.println(result);
	    }else {
		printDescription();
		return;
	    }
	}catch(NumberFormatException e){
	    printDescription();
	    return;
	}
	    
    }

}
