/* Implementation of a Deque class
   using an array to store the elements
 */
class  MyDeque implements Queue, Stack{
    private String[] content;
    private int size, tail, head;

    /* Instantiates a deque. Takes maximal size as input
     */
    public MyDeque(int sz){
	size = sz;
	tail=0;
	head=0;
	content = new String[10];
    }

    /* Checks if the deque is empty return true if it is, false if it
     * is not.
     */
    public boolean isEmpty(){
	return tail==head;
    }

    /* Pushes a new item to the head of the deque if there is space,
     * otherwise does nothing
     */
    public void push(String item){
	if((head+1)%size != tail){
	    content[head] = item;
	    head = (head + 1)%size;	    
	}
    }

    /* Enqueue an item at the end of the deque if there is spcace,
     * otherwise does nothing.
     */
    public void enqueue(String item){
	if((tail+size-1) % size != head){
	    tail = (tail + size - 1)%size;
	    content[tail]=item;
	}
    }


    /* If the deque is not empty, removes and returns the value at the
     * head of the deque.  Otherwise returns null.
     */
    public String pop(){
	if(head==tail)
	    return null;
	head = (head+size-1)%size;
	String rslt= content[head];
	return rslt;	
    }

    /* If the deque is not empty, removes and returns the value at the
     * tail of the deque.  Otherwise returns null.
     */
    public String dequeue(){
	if(head==tail)
	    return null;
	String rslt= content[tail];
	tail = (tail+1)%size;
	return rslt;
    }

    /* Prints content of the deque
     */
    public String toString(){
	String rslt="< ";

	for(int i = tail; i != head; i = (i+1)%size){
	    rslt = rslt + " " + content[i];
	}
	return rslt + " >";
    }

}
