package tripp;
import java.util.Scanner;
import java.util.*;

class TrippTrappTrull{

    private String[][] board;
    private String player;

    /* Initializes board and player
     */
    public TrippTrappTrull(){
	board = new String[3][3];
	player = "x";
    }

    /* Prints board
     */
    public String toString(){
	String str="";
	for(int row = 0; row < 3; row ++){
	    str += (row + 1) + " ";
	    for(int col = 0; col < 3; col++){
		str += (board[row][col]==null? "." : board[row][col]) + " ";
	    }
	    str += "\n";
	}
	str += "  ";
	for(int col = 0; col < 3; col++){
	    str += (col + 1) + " ";

	}
	str += "\n";	
	return str;	
    }

    /* Sets position (row,col) to the content of player;
     */
    private void set(int row, int col){
    	board[row][col]=player;
    }

    /* Returns true exactly when the position at (row,col) is free
     */
    private boolean isFree(int row, int col){
	return board[row][col]==null;
    }

    /* Retrurns true when there is at least a free position. Returns
       false otherwise.
     */
    private boolean thereAreFreeCells(){
	for(int i = 0; i<3; i++)
	    for(int j=0; j<3; j++)
		if(isFree(i,j))
		    return true;
	return false;
    }

    /* Checks whether there is a horizontal, vertical, 
       left diagonal or right diagonal line passing by THREE
       EQUAL AND NON NULL positions including the position (row,col).
       Returns true if it is the case, false otherwise. 
     */
    private boolean won(int row, int col){
	if(board[row][col]==null)
	    return false;      

	// first row
	if(row == 0)
	    if(board[0][0] == board[0][1] && board[0][1] == board[0][2])
		return true;

	//second row
	if(row == 1)
	    if(board[1][0] == board[1][1] && board[1][1] == board[1][2])
		return true;

	//third row
	if(row == 2)
	    if(board[2][0] == board[2][1] && board[2][1] == board[2][2])
		return true;

	//fist column
	if(col == 0)
	    if(board[0][0] == board[1][0] && board[1][0] == board[2][0])
		return true;

	//second column
	if(col == 1)
	    if(board[0][1] == board[1][1] && board[1][1] == board[2][1])
		return true;

	//third column
	if(col == 2)
	    if(board[0][2] == board[1][2] && board[1][2] == board[2][2])
		return true;

	//digonal
	if(row == col)
	    if(board[0][0] == board[1][1] && board[1][1] == board[2][2])
		return true;

	//anti diagonal
	if(row + col == 2)
	    if(board[2][0] == board[1][1] && board[1][1] == board[0][2])
		return true;

	return false;
				
    }

    /* Keeps asking the user for an integer in the range [min,max]
       (both inclusive) and return the first entered integer in that
       range.  
     */
    static private int getPosition(int min, int max){
	int pos=0;
	boolean askAgain=false;
	do{
	    try{
		System.out.println("enter an integer between " + min + " and " + max);
		Scanner scan = new Scanner(System.in);
		askAgain=false;
		pos = scan.nextInt();
		if(!(min <= pos && pos <= max))
		    askAgain=true;
	    }catch(InputMismatchException e){
		askAgain = true;
	    }
	}while(askAgain);
	return pos;	    
    }


    /* Switches player between "x"  and "o"
     */
    private void switchPlayer(){
	if(player.equals("x"))
	    player = "o";
	else
	    player = "x";
    }

    
    /* Starts an interactive tripp trapp trull game
     * asks two players for there moves untill one wins 
     * or there are no moves possible
     */
    public static void main(String[] args){
	TrippTrappTrull ttt = new TrippTrappTrull();
	int row, col;
	do{
	    ttt.switchPlayer();
	    System.out.println(ttt);
	    do{
		System.out.println("player " + ttt.player + ": choose a free position please ");
		System.out.print("row: ");
		row = getPosition(1,3) - 1;
		System.out.print("column:");
		col = getPosition(1,3) - 1;
	    } while(!ttt.isFree(row,col));	    	    
	    ttt.set(row,col);
	}while(!ttt.won(row,col) && ttt.thereAreFreeCells());

	System.out.println(ttt);

	if(ttt.won(row,col))
	    System.out.println("Player " + ttt.player + " wins!");
	else
	    System.out.println("No one wins.");
    }

}
